package creim;

import java.io.File;
import java.io.IOException;
import javalib.util.StringUtil;



public class Config {
	public static final File    PROJECT_ROOT   = new File(".");
	public static final File    TEST_ROOT      = new File("test");
	public static final File    SPOTIFY_ROOT   = new File("spotify");
	public static final File    OUTPUT_ROOT    = new File("output");
	public static final int     EFFECT_THREADS = 1;
	public static final String  SPOTIFY_CRED;
	public static final String  SPOTIFY_USR_ID;
	
	static {
		if (!TEST_ROOT.exists())
			TEST_ROOT.mkdirs();
		
		if (!SPOTIFY_ROOT.exists())
			SPOTIFY_ROOT.mkdirs();
		
		if (!OUTPUT_ROOT.exists())
			OUTPUT_ROOT.mkdirs();
		
		SPOTIFY_CRED = load("spotify.cred");
		SPOTIFY_USR_ID = SPOTIFY_CRED.split(":")[0];
	}
	
	
	private static String load(String filename) {
		try {
			return StringUtil.fromFile(filename);
		} catch (IOException e) {
			System.out.println("Failed to load "+filename);
			System.exit(1);
			return null;
		}
	}
}
