package creim.analysis.audio;

import creim.analysis.audio.spotifyapi.SpotifyAudioFeatures;



public class AudioAnalysisResult {
	
	public double[][]     musicdata;
	public double[]       meanFrequencies;
	public double[]       meanAmplitudesPerTime;
	public double[]       meanAmplitudesPerFrequency;
	public double[]       stdFrequencies;
	public double[][]     zones;
	
	public SpotifyAudioFeatures  spotifyanalysis;
	public String           spotifypreview;

	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		
		sb.append("AudioAnalysis{\n\t");
		sb.append(String.format("musicdata: [time_steps: %d, frequencies: %d]\n\t", musicdata.length, musicdata[0].length));
		sb.append(String.format("meanFrequencies: [%d]\n\t", meanFrequencies.length));
		sb.append(String.format("meanAmplitudesPerTime: [%d]\n\t", meanAmplitudesPerTime.length));
		sb.append(String.format("meanAmplitudesPerFrequency: [%d]\n\t", meanAmplitudesPerFrequency.length));
		sb.append(String.format("stdFrequencies: [%d]\n\t", stdFrequencies.length));
		sb.append(String.format("zones: [time_steps: %d, frequencies: %d]\n", zones.length, zones[0].length));
		sb.append("\n");
		sb.append(String.format("\tPreview url: %s\n", spotifypreview));
		sb.append("\n");
		for (String s : spotifyanalysis.toString().split("\n")) {
			sb.append("\t");
			sb.append(s);
			sb.append("\n");
		}
		sb.append("\n");
		sb.append("}");
		
		return sb.toString();
	}
	
}
