package creim.art.artist.description;

import creim.art.artist.Artist;
import java.awt.image.BufferedImage;
import javalib.util.RandomUtil;
import creim.art.painter.ClearPainter;
import creim.art.painter.RectanglePainter;
import creim.business.Description;



public class DescriptionArtist extends Artist {

	private Description description;
	
	public DescriptionArtist(int width, int height, Description description) {
		super(width, height);
		this.description = description;
	}

	
	@Override
	public BufferedImage paint() {
		
		ClearPainter cp = new ClearPainter(width, height);
		cp.paintOn(image);
		
		
		if (description.useboxes) {
			int boxes = RandomUtil.nextInt(description.boxesCountDom.min, description.boxesCountDom.max);
			
			for (int i = 0; i < boxes; i++) {
				int x = RandomUtil.nextInt(description.boxesPointMin.x, description.boxesPointMax.x);
				int y = RandomUtil.nextInt(description.boxesPointMin.y, description.boxesPointMax.y);
				int w = RandomUtil.nextInt(description.boxesMinDim.width, description.boxesMaxDim.width);
				int h = RandomUtil.nextInt(description.boxesMinDim.height, description.boxesMaxDim.height);
				
				RectanglePainter sp = new RectanglePainter(x, y, w, h, 0);
				sp.color = description.palette[RandomUtil.nextInt(description.palette.length)];
				sp.paintOn(image);
			}
		}
		
		
		
		return image;
	}
	
}
