package creim.art.artist.ea;

import creim.util.DomainFloat;


/**
 *
 * @author Viktor
 */
public enum ToolParameter {
	ColorDeg, 
	ColorDist, 
	ColorSMin, 
	ColorSMax,
	ColorS,
	ColorBMin, 
	ColorBMax,
	ColorB,
	
	StraightBrushStrokes,
	StraightBrushWidthMin,
	StraightBrushWidthMax,
	StraightBrushLengthMin,
	StraightBrushLengthMax,
	StraightBrushRotationMin,
	StraightBrushRotationMax,
	
	CurveBrushStrokes,
	CurveBrushWidthMin,
	CurveBrushWidthMax,
	
	RectangleStrokes,
	RectangleWidthMin,
	RectangleWidthMax,
	RectangleLengthMin,
	RectangleLengthMax,
	
	OvalStrokes,
	OvalWidthMin,
	OvalWidthMax,
	OvalLengthMin,
	OvalLengthMax,
	
	PolygonStrokes,
	PolygonPointsMin,
	PolygonPointsMax,
	
	BlurEffect,
//	OilEffect,
	;
	
	public static DomainFloat getOutputDomain(ToolParameter param) {
		if (param == null)
			return null;
		
		switch (param) {
			case ColorDeg:                   return new DomainFloat(0, 360);
			case ColorDist:                  return new DomainFloat(0, 360);
			case ColorSMin:                  return new DomainFloat(0, 1);
			case ColorSMax:                  return new DomainFloat(0, 1);
			case ColorS:                     return new DomainFloat(0, 1);
			case ColorBMin:                  return new DomainFloat(0, 1);
			case ColorBMax:                  return new DomainFloat(0, 1);
			case ColorB:                     return new DomainFloat(0, 1);
			
			case StraightBrushStrokes:       return new DomainFloat(0, 500);
			case StraightBrushWidthMin:      return new DomainFloat(0, 1000);
			case StraightBrushWidthMax:      return new DomainFloat(0, 1000);
			case StraightBrushLengthMin:     return new DomainFloat(0, 1000);
			case StraightBrushLengthMax:     return new DomainFloat(0, 1000);
			case StraightBrushRotationMin:   return new DomainFloat(0, 360);
			case StraightBrushRotationMax:   return new DomainFloat(0, 360);
			
			case CurveBrushStrokes:          return new DomainFloat(0, 500);
			case CurveBrushWidthMin:         return new DomainFloat(0, 100);
			case CurveBrushWidthMax:         return new DomainFloat(0, 100);
			
			case RectangleStrokes:           return new DomainFloat(0, 500);
			case RectangleWidthMin:          return new DomainFloat(0, 1000);
			case RectangleWidthMax:          return new DomainFloat(0, 1000);
			case RectangleLengthMin:         return new DomainFloat(0, 1000);
			case RectangleLengthMax:         return new DomainFloat(0, 1000);
			
			case OvalStrokes:                return new DomainFloat(0, 500);
			case OvalWidthMin:               return new DomainFloat(0, 1000);
			case OvalWidthMax:               return new DomainFloat(0, 1000);
			case OvalLengthMin:              return new DomainFloat(0, 1000);
			case OvalLengthMax:              return new DomainFloat(0, 1000);
			
			case PolygonStrokes:             return new DomainFloat(0, 100);
			case PolygonPointsMin:           return new DomainFloat(0, 10);
			case PolygonPointsMax:           return new DomainFloat(0, 10);
			
			case BlurEffect:                 return new DomainFloat(0, 10);
			
			default: 
				throw new UnsupportedOperationException("Missing output domain");
		}
	}
}