/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package creim.art.artist.ea.fitnesscalculators;

import creim.analysis.audio.spotifyapi.SpotifyAudioFeatures;
import creim.art.artist.ea.ArtistGenotype;
import creim.art.artist.ea.MappingArtist;
import creim.art.painter.Painter;
import creim.util.Logger;
import eval.models.Genotype;
import java.awt.Dimension;
import java.util.ArrayList;

/**
 *
 * @author Vikto
 */
public class ImageAnalysisFitnessCalculator extends FitnessCalculator {

	private final Dimension imagedim;
	private final SpotifyAudioFeatures[] features;
	private final ArtistGenotype artistGenotype;
	private final ArrayList<MappingArtist> artists;
	
	
	public ImageAnalysisFitnessCalculator(Genotype g, Dimension imagedim, SpotifyAudioFeatures[] features) {
		this.artistGenotype = (ArtistGenotype) g;
		this.features = features;
		this.imagedim = imagedim;
		this.artists = new ArrayList<>();
	}
	
	
	public void init() {
		if (artists.size() == features.length)
			return;
		
		for (SpotifyAudioFeatures feature : features) {
			MappingArtist artist = new MappingArtist(imagedim, feature, artistGenotype, false);
			this.artists.add(artist);
		}
	}
	
	
	@Override
	public double calculateFitness() {
		return avgStrokeArea();
	}
	
	
	public double avgStrokeArea() {
		init();
		
		double sum = 0;
		for (MappingArtist artist : artists) {
			double currentsum = 0;
			ArrayList<Painter> painters = artist.painters;
			for (Painter painter : painters) {
				currentsum += painter.area();
			}
			double currentavg = currentsum / painters.size();
			ArtistGenotype geno = artist.genotype;
			Logger.debug("Current area avg: "+ currentavg);

			sum += currentavg;
		}

		double avg = sum / artists.size();
		return avg;
	}
}
