/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package creim.art.artist.ea.fitnesscalculators;

import creim.analysis.audio.spotifyapi.SpotifyAudioFeatures;
import creim.art.artist.ea.ArtistGenotype;
import creim.art.artist.ea.FeatureVariable;
import creim.art.artist.ea.GenotypeEntry;
import creim.art.artist.ea.MappingArtist;
import creim.art.artist.ea.ToolParameter;
import creim.art.painter.Painter;
import creim.util.Logger;
import eval.models.Genotype;
import java.awt.Color;
import java.awt.Dimension;
import java.util.ArrayList;

/**
 *
 * @author Vikto
 */
public class TargetDistanceFitnessCalculator extends FitnessCalculator {

	
	private final Dimension imagedim;
	private final SpotifyAudioFeatures[] features;
	private final ArtistGenotype artistGenotype;
	private MappingArtist artist;
	public static final double KEY_MISMATCH_MULT = 2;
	public static final double KEY_NOT_DEFINED_MULT = 1;
	public static final double KEY_MATCH_MULT = 1;
	public static boolean NO_RANDOM_GENERATOR = false;
	
	
	public TargetDistanceFitnessCalculator(Genotype g, Dimension imagedim, SpotifyAudioFeatures[] features) {
		this.artistGenotype = (ArtistGenotype) g;
		this.features = features;
		this.imagedim = imagedim;
	}
	
	
	@Override
	public double calculateFitness() {
		double fitnesssum = 0;
		for (int i = 0; i < features.length; i++) {
			artist = new MappingArtist(imagedim, features[i], artistGenotype, false);

			ArrayList<Painter> painters = artist.painters;
			Color[] palette = artist.palette;

			ArtistGenotype geno = artist.genotype;
			Logger.debug(artist.genotype);

			fitnesssum += distanceAllParams();
			
			// manipulate weigths on each part
//			fitnesssum += dist(ToolParameter.ColorDeg) + dist(ToolParameter.ColorDist) 
//					+ dist(ToolParameter.ColorSMin) + dist(ToolParameter.ColorSMax)+ dist(ToolParameter.ColorBMin) + dist(ToolParameter.ColorBMax)
//					+ dist(ToolParameter.StraightBrushStrokes) + dist(ToolParameter.StraightBrushRotationMax)
//					+ dist(ToolParameter.CurveBrushStrokes) + dist(ToolParameter.CurveBrushWidthMax) + dist(ToolParameter.CurveBrushWidthMin)
//					+ dist(ToolParameter.BlurEffect);
		}

		double avg = fitnesssum / features.length;
		return avg;
//		return Math.exp(-0.005 * avg);
	}
	
	
	public double distanceAllParams() {
		double distsum = 0;
		for (ToolParameter param : ToolParameter.values()) {
			distsum += dist(param);
		}
		return distsum;
	}
	
	
	public double dist(ToolParameter param) {
		GenotypeEntry target = FitnessTarget.genotype.getEntry(param);
		GenotypeEntry current = artist.genotype.getEntry(param);
		
		if (target == null)
			return 0;
		
		double mult;
		if (target.variable == current.variable) 
			mult = KEY_MATCH_MULT;
		else if (target.variable == FeatureVariable.RANDOM_GENERATOR && NO_RANDOM_GENERATOR)
			mult = KEY_MISMATCH_MULT;
		else if (target.variable == null)
			mult = KEY_NOT_DEFINED_MULT;
		else
			mult = KEY_MISMATCH_MULT;
		
		double min = Math.abs(target.outputmin - current.outputmin);
		double max = Math.abs(target.outputmax - current.outputmax);
		
		if (target.ignoreoutputmin)
			min = 0;
		if (target.ignoreoutputmax)
			max = 0;
		
		double dist = min + max;
		if (dist == 0 && mult != 1)
			return mult;
		return dist * mult;
	}
	

}
