package creim.art.models;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Shape;
import java.awt.geom.CubicCurve2D;
import java.util.ArrayList;
import javalib.util.RandomUtil;
import creim.oldea.EAMutable;



public class CurveBrushModel extends PainterModel implements EAMutable {
	
	public float brushwidth;
	public Color brushcolor;
	public ArrayList<Shape> shapes;

	public CurveBrushModel() {
		this(25, Color.BLACK);
	}

	public CurveBrushModel(float brushwidth, Color brushcolor) {
		this(brushwidth, brushcolor, null);
	}
	public CurveBrushModel(float brushwidth, Color brushcolor, ArrayList<Shape> shapes) {
		this.brushwidth = brushwidth;
		this.brushcolor = brushcolor;
		if (shapes == null)
			this.shapes = new ArrayList<>();
		else
			this.shapes = shapes;
	}
	
	public void addShape(Shape s) {
		shapes.add(s);
	}

	@Override
	public void randomize() {
		brushwidth = RandomUtil.nextInt(75);
		brushcolor = palette[RandomUtil.nextInt(palette.length)];
		int  x1 = RandomUtil.nextInt(-margin, imagedim.width + margin);
		int  y1 = RandomUtil.nextInt(-margin, imagedim.height + margin);
		int cx1 = RandomUtil.nextInt(-margin, imagedim.width + margin);
		int cy1 = RandomUtil.nextInt(-margin, imagedim.height + margin);
		int cx2 = RandomUtil.nextInt(-margin, imagedim.width + margin);
		int cy2 = RandomUtil.nextInt(-margin, imagedim.height + margin);
		int  x2 = RandomUtil.nextInt(-margin, imagedim.width + margin);
		int  y2 = RandomUtil.nextInt(-margin, imagedim.height + margin);

		CubicCurve2D.Float shape = new CubicCurve2D.Float(x1, y1, cx1, cy1, cx2, cy2, x2, y2);
		addShape(shape);
	}

	@Override
	public void mutate(Dimension imagedim, Color[] palette, int margin) {
		
		int p = RandomUtil.nextInt(10);
		
		CubicCurve2D.Float shape = (CubicCurve2D.Float)shapes.get(0);
		if (shape == null) {
			throw new RuntimeException("Shapes is null...");
		}
		
		if (p == 0)
			brushwidth = RandomUtil.nextInt(75);
		else if (p == 1)
			brushcolor = palette[RandomUtil.nextInt(palette.length)];
		else if (p == 2)
			shape.x1 = RandomUtil.nextInt(-margin, imagedim.width + margin);
		else if (p == 3)
			shape.y1 = RandomUtil.nextInt(-margin, imagedim.height + margin);
		else if (p == 4)
			shape.ctrlx1 = RandomUtil.nextInt(-margin, imagedim.width + margin);
		else if (p == 5)
			shape.ctrly1 = RandomUtil.nextInt(-margin, imagedim.height + margin);
		else if (p == 6)
			shape.ctrlx2 = RandomUtil.nextInt(-margin, imagedim.width + margin);
		else if (p == 7)
			shape.ctrly2 = RandomUtil.nextInt(-margin, imagedim.height + margin);
		else if (p == 8)
			shape.x2 = RandomUtil.nextInt(-margin, imagedim.width + margin);
		else if (p == 9)
			shape.y2 = RandomUtil.nextInt(-margin, imagedim.height + margin);
	}
	
}
