package creim.art.models;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Point;
import java.util.ArrayList;
import javalib.util.RandomUtil;
import creim.oldea.EAMutable;



public class PolygonModel extends PainterModel implements EAMutable {
	
	public Color color = Color.WHITE;
	public Color outlineColor = Color.BLACK;
	public float outlineThickness = 0.0f;
	public ArrayList<Point> points;

	public PolygonModel() {
		this.points = new ArrayList<>();
	}

	public PolygonModel(ArrayList<Point> points) {
		this.points = points;
	}
	
	
	public void addPolygonPoint(int x, int y) {
		points.add(new Point(x, y));
	}
	
	public void addPolygonPoint(Point point) {
		points.add(point);
	}

	@Override
	public void randomize() {
		color = palette[RandomUtil.nextInt(palette.length)];
		outlineColor = palette[RandomUtil.nextInt(palette.length)];
		outlineThickness = RandomUtil.nextInt(5);

		int count = RandomUtil.nextInt(3, 7);
		for (int c = 0; c < count; c++) {
			Point p = new Point();
			p.x = RandomUtil.nextInt(-margin, imagedim.width + margin);
			p.y = RandomUtil.nextInt(-margin, imagedim.height + margin);
			addPolygonPoint(p);
		}
	}
	
	
	
	

	@Override
	public void mutate(Dimension imagedim, Color[] palette, int margin) {
		int p = RandomUtil.nextInt(3 + this.points.size());
		if (p == 0)
			color = palette[RandomUtil.nextInt(palette.length)];
		else if (p == 1)
			outlineColor = palette[RandomUtil.nextInt(palette.length)];
		else if (p == 2)
			outlineThickness = RandomUtil.nextInt(5);
		else {
			int i = p - 3;
			Point point = points.get(i);
			if (RandomUtil.RNG.nextBoolean())
				point.x = RandomUtil.nextInt(-margin, imagedim.width + margin);
			else
				point.y = RandomUtil.nextInt(-margin, imagedim.height + margin);
		}
	}
	
	
}
