package creim.graphics.colors;

public class RYB {

	public float r;
	public float y;
	public float b;

	public RYB() {
	}

	public RYB(float r, float y, float b) {
		this.r = r;
		this.y = y;
		this.b = b;
	}

	@Override
	public String toString() {
		return "RYB{" + "r=" + r + ", y=" + y + ", b=" + b + '}';
	}

	


	private float cubicInt(float t, float A, float B) {
		float weight = t * t * (3 - 2 * t);
		return A + weight * (B - A);
	}

	public RGB toRGBInterpolated() {
		float x0, x1, x2, x3, y0, y1;
		float iR = r;
		float iY = y;
		float iB = b;
		//red
		x0 = cubicInt(iB, 1.0f, 0.163f);
		x1 = cubicInt(iB, 1.0f, 0.0f);
		x2 = cubicInt(iB, 1.0f, 0.5f);
		x3 = cubicInt(iB, 1.0f, 0.2f);
		y0 = cubicInt(iY, x0, x1);
		y1 = cubicInt(iY, x2, x3);
		float oR = cubicInt(iR, y0, y1);
		//green
		x0 = cubicInt(iB, 1.0f, 0.373f);
		x1 = cubicInt(iB, 1.0f, 0.66f);
		x2 = cubicInt(iB, 0.0f, 0.0f);
		x3 = cubicInt(iB, 0.5f, 0.094f);
		y0 = cubicInt(iY, x0, x1);
		y1 = cubicInt(iY, x2, x3);
		float oG = cubicInt(iR, y0, y1);
		//blue	
		x0 = cubicInt(iB, 1.0f, 0.6f);
		x1 = cubicInt(iB, 0.0f, 0.2f);
		x2 = cubicInt(iB, 0.0f, 0.5f);
		x3 = cubicInt(iB, 0.0f, 0.0f);
		y0 = cubicInt(iY, x0, x1);
		y1 = cubicInt(iY, x2, x3);
		float oB = cubicInt(iR, y0, y1);
		
		return new RGB(oR, oG, oB);
	}
}
