package creim.oldea;


import eval.models.Phenotype;
import java.awt.Color;
import java.awt.image.BufferedImage;
import creim.analysis.image.ImageAnalyzer;
import creim.art.painter.*;
import creim.graphics.effect.BlurEffect;
import creim.graphics.effect.OilifyEffect;



public class ArtPhenotype extends Phenotype {
	
	public BufferedImage image;
	

	public ArtPhenotype(ArtGenotype g) {
		super(g);
	}
	
	

	@Override
	public double calculateFitness() {
		ArtGenotype g = (ArtGenotype)genotype;
		image = new BufferedImage(g.imagedim.width, g.imagedim.height, BufferedImage.TYPE_INT_ARGB);
		
		ClearPainter cp = new ClearPainter(g.imagedim.width, g.imagedim.height, Color.black);
		cp.paintOn(image);
		
		
		for (Painter painter : g.painters) {
			painter.paintOn(image);
		}
		
		OilifyEffect oil = new OilifyEffect(image, 5, 25);
		oil.applyInplace();

		BlurEffect blur = new BlurEffect(image, 1);
		blur.applyInplace();
			
		ImageAnalyzer analyzer = new ImageAnalyzer(image);
		return 1.0 - analyzer.percentOfColor(Color.black, 50);
	}

}
