package master;

import creim.analysis.audio.spotifyapi.SpotifyAPI;
import creim.analysis.audio.spotifyapi.SpotifyAudioFeatures;
import creim.art.artist.ea.ArtistGenotype;
import creim.art.artist.ea.MappingArtist;
import creim.gui.ImageFrame;
import java.awt.Dimension;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;
import javax.imageio.ImageIO;


public class TestGenotype {
	
//	public static String[] trackids = {"spotify:track:4zHzxmGa8ywcOBBvPvnYcp"};
//	public static String[] trackids = {"spotify:track:2BbCxjtf2UXaQhhsclivrn"};
	public static String[] trackids = {"spotify:track:2L8ZiTLLejiY9O7qhhoday", "spotify:track:5f2CgxUSiRtuEMcY6mmAW4", "spotify:track:6qTJtlUrLTrZLUuS81SPI7", "spotify:track:2iNRom9yU8lY7SEw6JCiBA", "spotify:track:5pD9x23lsoQr464mlmaKNJ", "spotify:track:5ChkMS8OtdzJeqyybCc9R5"};
	
	public static void main(String[] args) throws IOException {
		SimpleDateFormat format = new SimpleDateFormat("YYYY-MM-dd_HH-mm-ss");
		Dimension imagedim = new Dimension(800, 800);
		
		ArtistGenotype genotype = new ArtistGenotype();
		genotype.deserialize(new File("genotype_tailored_test.csv"));
//		genotype.deserialize(new File("output/user_combo/save_2017-05-19_14-34-42/genotype_309.92085636757.csv"));
		
		File root = new File("output/user_combo/custom/save_"+ format.format(new Date()));
		
		
		multiple(imagedim, root, genotype);
	}
	
	
	public static void single(Dimension imagedim, File outputroot, ArtistGenotype genotype) throws IOException {
		SpotifyAPI sapi = new SpotifyAPI();
		
		for (String trackid : trackids) {
			SpotifyAudioFeatures features = sapi.getAudioFeatureObject(trackid);
			MappingArtist ma = new MappingArtist(imagedim, features, genotype, true);
			BufferedImage image = ma.paint();
			String name = sapi.getTrackName(trackid);
			ImageFrame frame = new ImageFrame(image);
			frame.setTitle(name);
			frame.setVisible(true);
		}
	}
	
	public static void multiple(Dimension imagedim, File outputroot, ArtistGenotype genotype) throws IOException {
		SpotifyAPI sapi = new SpotifyAPI();
		outputroot.mkdirs();
		genotype.serialize(new File(outputroot, "genotype.csv"));
		for (String trackid : trackids) {
			SpotifyAudioFeatures features = sapi.getAudioFeatureObject(trackid);
			String name = sapi.getTrackName(trackid);
			File output = new File(outputroot, name);
			output.mkdirs();
			for (int i = 0; i < 10; i++) {
				MappingArtist ma = new MappingArtist(imagedim, features, genotype, true);
				BufferedImage image = ma.paint();
				ImageIO.write(image, "PNG", new File(output, name+"_"+i+".png"));
			}
		}
	}
}
