package master.tests.artist;

import java.awt.Color;
import java.awt.image.BufferedImage;
import javalib.util.RandomUtil;
import creim.art.artist.Artist;
import creim.graphics.colors.RYBColorWheel;
import creim.graphics.effect.BlurEffect;
import creim.graphics.effect.OilifyEffect;
import creim.art.painter.ClearPainter;
import creim.art.painter.StraightBrushPainter;
import creim.util.Logger;



//TODO: these circles can follow the high tones avg frequency line

public class TestArtist2 extends Artist {

	public TestArtist2(int width, int height) {
		super(width, height);
	}

	@Override
	public BufferedImage paint() {
		
		ClearPainter clear = new ClearPainter(width, height);
		clear.paintOn(image);
		
		Logger.info("Strokes ...");
		Color[] palette = RYBColorWheel.adjacent(240, 10);
		for (int i = 0; i < palette.length; i++) {
			palette[i] = palette[i].brighter();
		}
		
		int count = 60;
		for (int i = 0; i < count; i++) {
			int x = RandomUtil.nextInt(-50, width+50);
			int y = RandomUtil.nextInt(-50, height+50);
			int w = RandomUtil.nextInt(5, 500);
			int h = RandomUtil.nextInt(5, 1000);
			double a = RandomUtil.nextDouble(0, 360);
			
			StraightBrushPainter p = new StraightBrushPainter(x, y, w, h, palette[RandomUtil.nextInt(palette.length)], a);
			
			p.brushcolor = palette[RandomUtil.nextInt(palette.length)];
			p.paintOn(image);
		}
		
		Logger.info("Oil ...");
		OilifyEffect ef = new OilifyEffect(image, 5, 15);
		ef.applyInplace();
		
		Logger.info("Blur ...");
		BlurEffect bf = new BlurEffect(image, 1);
		bf.applyInplace();
		
		return image;
	}
	
	
	public static void main(String[] args) {
		TestArtist2 t = new TestArtist2(400, 1000);
		t.clear();
		t.paint();
		t.display(Color.WHITE);
	}
}
