package master.tests.artist;

import java.awt.Color;
import java.awt.image.BufferedImage;
import creim.analysis.image.ImageAnalyzer;
import creim.art.artist.Artist;
import creim.gui.ColorFrame;
import creim.graphics.colors.ColorUtil;
import creim.graphics.colors.RYB;



public class TestArtist3 extends Artist {

	public TestArtist3(int width, int height) {
		super(width, height);
	}

	@Override
	public BufferedImage paint() {
//		Graphics2D g2 = (Graphics2D)image.getGraphics();
		for (int i = 0; i < width; i++) {
			for (int j = 0; j < height; j++) {
//				image.setRGB(i, j, RYBColorWheel.at(RandomUtil.nextInt(360)).getRGB());
				image.setRGB(i, j, ColorUtil.randomColor().getRGB());
			}
		}
		return image;
	}

	public static void main(String[] args) {
		TestArtist3 t = new TestArtist3(800, 800);
		t.paint();
		t.display(Color.WHITE);
		BufferedImage out = t.getImage();
		ImageAnalyzer ia = new ImageAnalyzer(out);
		System.out.println(ia.percentOfColor(Color.red, 0));
		
		Color mean = ia.meanColor();
		ColorFrame cf = new ColorFrame(mean);
		cf.setVisible(true);
		System.out.println(ia.colorVariation());
		
		RYB ryb = new RYB(1, 1, 1);
		Color color = ryb.toRGBInterpolated().toColor();
		ColorFrame cf2 = new ColorFrame(color);
		cf2.setVisible(true);
		
	}
}
