/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package master.tests.software;

import creim.art.painter.Painter;
import creim.graphics.colors.ColorPalette;
import creim.gui.ImageFrame;
import creim.util.Logger;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.image.BufferedImage;
import javalib.util.RandomUtil;
import org.apache.commons.collections4.list.TreeList;

/**
 *
 * @author Vikto
 */
public class ImageCreationTest {
	
	public static void main(String[] args) {
		Dimension imagedim = new Dimension(800, 800);
		int margin = (int)(Math.max(imagedim.width, imagedim.height) * 0.1);
		
		Color[] palette = ColorPalette.generateRandomPastelPalette();
		
		int num_models = RandomUtil.nextInt(50);
		TreeList<Painter> painters = new TreeList<>();
		for (int j = 0; j < num_models; j++) {
			Painter painter = Painter.randomPainter(imagedim, margin, palette);
			painters.add(painter);
		}
		
		BufferedImage image = new BufferedImage(imagedim.width, imagedim.height, BufferedImage.TYPE_INT_ARGB);
		for (Painter p : painters) {
			Logger.debug(p);
			p.paintOn(image);
		}
		
		ImageFrame frame = new ImageFrame(image);
		frame.setVisible(true);
	}
	
}
